/*
    myrrdin, a 2d tile engine
    Copyright (c) 2008 Friedrich Weber

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the Software), to deal
    in the Software without restriction, including without limitation the rights
    to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in
    all copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
    THE SOFTWARE.
 */

module testviewconsumer;

import dsfml.window.all;
import dsfml.system.all;
import dsfml.graphics.all;

import myrrdin.tileconsumer;
import myrrdin.renderer;
import myrrdin.consumer;
import myrrdin.imagecache;
import myrrdin.tilemap;
import myrrdin.tileset;
import myrrdin.xmlmap;
import myrrdin.tools;
import myrrdin.viewconsumer;
import myrrdin.animatedsprite;
import myrrdin.spriteconsumer;
import myrrdin.movingfigure;

int main(char[][] args) {
    Cache cache = new Cache("gfx");
    Tilemap map = parse_map(cache, read_file_contents("map-example.xml"));
    Renderer render = new Renderer("Blubb", 600, 480, 32);
    render.add_consumer(new InteractiveViewConsumer(render));
    TileConsumer consumer = new TileConsumer(render, map);
    map.set_view(render.app.getView());
    render.add_consumer(consumer);
    render.mainloop();
    return 0; 
}
